Canyon.GM.Panel/Areas/Articles/Pages/List.cshtml.cs
using Canyon.GM.Panel.Models.Articles;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;

namespace Canyon.GM.Panel.Areas.Articles.Pages
{
    [Authorize]
    public class ListModel : PageModel
    {
        private readonly ArticleService articleService;

        public ListModel(ArticleService articleService)
        {
            this.articleService = articleService;
        }

        public List<ArticleCategoriesType> ArticleCategoriesTypes { get; set; } = new();

        public async Task<IActionResult> OnGetAsync()
        {
            var articleCategorieTypes = await articleService.QueryActiveArticleCategoryTypeAsync();
            foreach (ArticleCategoryTypeModel type in articleCategorieTypes)
            {
                var cat = new ArticleCategoriesType
                {
                    Id = type.Id,
                    Name = type.Name,
                    Categories = new List<ArticleCategory>()
                };

                List<ArticleCategoryModel> categories = await articleService.QueryActiveArticleCategoriesByTypeAsync(type.Id);
                foreach (var category in categories)
                {
                    var childCat = new ArticleCategory
                    {
                        Id = category.Id,
                        Name = category.Name,
                        RealName = category.RealName,
                        Articles = await articleService.QueryByCategoryAsync(category.Id, 0, 25)
                    };
                    cat.Categories.Add(childCat);
                }
                ArticleCategoriesTypes.Add(cat);
            }
            return Page();
        }

        public struct ArticleCategoriesType
        {
            public int Id { get; set; }
            public string Name { get; set; }
            public List<ArticleCategory> Categories { get; set; }
        }

        public struct ArticleCategory
        {
            public int Id { get; set; }
            public string RealName { get; set; }
            public string Name { get; set; }
            public List<AdminArticleListModel> Articles { get; set; }
        }
    }
}

Canyon.GM.Panel/Areas/CreditCard/Pages/List.cshtml.cs
using Canyon.GM.Panel.Database.Entities.Local;
using Canyon.GM.Panel.Services.Identity;
using Canyon.GM.Panel.Services.Logging;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using System.ComponentModel.DataAnnotations;

namespace Canyon.GM.Panel.Areas.CreditCard.Pages
{
    [Authorize(Roles = "ManageCreditCards")]
    public class ListModel : PageModel
    {
        private readonly ProductService productService;
        private readonly CreditCardService creditCardService;
        private readonly UserManager userManager;
        private readonly SignInManager signInManager;
        private readonly EventLogger logger;

        public ListModel(
            ProductService productService,
            CreditCardService creditCardService,
            UserManager userManager,
            SignInManager signInManager,
            EventLogger logger
            )
        {
            this.productService = productService;
            this.creditCardService = creditCardService;
            this.userManager = userManager;
            this.signInManager = signInManager;
            this.logger = logger;
        }

        [BindProperty]
        public InputModel Input { get; set; }

        public List<Product> Products { get; private set; } = new();

        [TempData]
        public Guid? CardId { get; set; }

        public async Task<IActionResult> OnGetAsync()
        {
            Products = await productService.GetActiveProductsAsync(0, int.MaxValue);
            return Page();
        }

        public async Task<IActionResult> OnPostAsync()
        {
            if (!ModelState.IsValid)
            {
                return await OnGetAsync();
            }

            var product = await productService.GetProductByIdAsync(Input.ProductId);
            if (product == null)
            {
                ModelState.AddModelError("Error", "InvalidProduct");
                return await OnGetAsync();
            }

            ApplicationUser currentUser = await userManager.GetUserAsync(User);
            if (currentUser == null)
            {
                await logger.LogAsync(EventLogger.LogType.CreditCardCreationAttempt, false, Input);
                await signInManager.SignOutAsync();
                return RedirectToPage();
            }

            var cards = await creditCardService.GenerateCreditCardsAsync(currentUser, product.CardTypeId, 1);
            if (cards.Count == 0)
            {
                await logger.LogAsync(EventLogger.LogType.CreditCardCreationAttempt, false, Input);
                ModelState.AddModelError("Error", "ErrorGeneratingCard");
                return await OnGetAsync();
            }

            await logger.LogAsync(EventLogger.LogType.CreditCardCreated, true, Input);
            CardId = cards.FirstOrDefault().CardUUID;
            return RedirectToPage();
        }

        public class InputModel
        {
            [Required]
            public Guid ProductId { get; set; }
        }
    }
}

Canyon.GM.Panel/Areas/Realm/Pages/Index.cshtml.cs
using Canyon.GM.Panel.Services.Logging;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using System.ComponentModel.DataAnnotations;

namespace Canyon.GM.Panel.Areas.Realm.Pages
{
    [Authorize(Roles = ROLE_MANAGE_USERS)]
    public class IndexModel : PageModel
    {
        private RealmService realmService;
        private readonly EventLogger eventLogger;
        private IStringLocalizer localizer;

        public IndexModel(
            IStringLocalizer localizer, 
            RealmService realmService,
            EventLogger eventLogger
            )
        {
            this.localizer = localizer;
            this.realmService = realmService;
            this.eventLogger = eventLogger;
        }

        [BindProperty(SupportsGet = true)]
        public Guid RealmID { get; set; }

        public RealmService.RealmPublicData Realm { get; set; }

        [BindProperty] public InputModel Input { get; set; }

        public async Task<IActionResult> OnGetAsync()
        {
            if (RealmID == Guid.Empty)
            {
                Input ??= new InputModel();
                return Page();
            }

            var realm = await realmService.FindByIdAsync(RealmID);
            if (realm == null)
            {
                return RedirectToPage("./Index");
            }

            await eventLogger.LogAsync(EventLogger.LogType.RealmView, true, new
            {
                RealmID
            });

            Realm = realmService.GetRealmData(realm);

            Input ??= new InputModel
            {
                DatabaseHost = Realm.DatabaseHostname,
                DatabasePort = (uint)Realm.DatabasePort,
                DatabaseSchema = Realm.DatabaseSchema,
                DatabaseUser = Realm.DatabaseUsername,

                Username = Realm.RealmUsername,

                GameIPAddress = Realm.GameIPAddress,
                GamePort = Realm.GamePort,

                RpcIPAddress = Realm.RpcIPAddress,
                RpcPort = Realm.RpcPort,

                RealmID = Realm.RealmID,
                RealmName = Realm.RealmName,

                GmToolsHost = Realm.GmToolsAddress,
                GmToolsPort = Realm.GmToolsPort,
                GmToolsUserName = Realm.GmToolsUsername,

                Active = Realm.Active,
                ProductionRealm = Realm.Production
            };

            return Page();
        }

        public async Task<IActionResult> OnPostAsync()
        {
            if (!ModelState.IsValid)
            {
                return Page();
            }

            EventLogger.LogType logType = EventLogger.LogType.Invalid;
            bool success = false;
            object data = new
            {
                RealmID,
                Input
            };
            try
            {
                if (RealmID == Guid.Empty)
                {
                    logType = EventLogger.LogType.RealmCreation;

                    var duplicate = await realmService.FindByNameAsync(Input.RealmName);
                    if (duplicate != null)
                    {
                        ModelState.AddModelError("Error", "DuplicateRealmName");
                        return Page();
                    }

                    if (string.IsNullOrEmpty(Input.DatabasePass) || string.IsNullOrEmpty(Input.Password))
                    {
                        ModelState.AddModelError("Error", "PasswordsCantBeEmptyOnCreation");
                        return Page();
                    }

                    if (!await realmService.CreateRealmAsync(new RealmService.CreateRealmModel
                    {
                        DatabaseHost = Input.DatabaseHost,
                        DatabasePass = Input.DatabasePass,
                        DatabasePort = Input.DatabasePort.ToString(),
                        DatabaseSchema = Input.DatabaseSchema,
                        DatabaseUser = Input.DatabaseUser,

                        GmToolsAddress = Input.GmToolsHost,
                        GmToolsPort = Input.GmToolsPort,
                        GmToolsUserName = Input.GmToolsUserName,
                        GmToolsPassword = Input.GmToolsPassword,

                        GameIPAddress = Input.GameIPAddress,
                        GamePort = Input.GamePort,
                        RpcIPAddress = Input.RpcIPAddress,
                        RpcPort = Input.RpcPort,

                        RealmName = Input.RealmName,
                        Username = Input.Username,
                        Password = Input.Password,

                        Active = Input.Active,
                        Production = Input.ProductionRealm
                    }))
                    {
                        ModelState.AddModelError("Error", localizer.GetString("CouldNotInsertRealm"));
                        return Page();
                    }

                    success = true;
                    return RedirectToPage("./Realm/List");
                }

                logType = EventLogger.LogType.RealmUpdate;
                if (!await realmService.UpdateRealmAsync(new RealmService.AlterRealmModel
                {
                    DatabaseHost = Input.DatabaseHost,
                    DatabasePass = Input.DatabasePass,
                    DatabasePort = Input.DatabasePort.ToString(),
                    DatabaseSchema = Input.DatabaseSchema,
                    DatabaseUser = Input.DatabaseUser,

                    GmToolsAddress = Input.GmToolsHost,
                    GmToolsPort = Input.GmToolsPort,
                    GmToolsUserName = Input.GmToolsUserName,
                    GmToolsPassword = Input.GmToolsPassword,

                    GameIPAddress = Input.GameIPAddress,
                    GamePort = Input.GamePort,
                    RpcIPAddress = Input.RpcIPAddress,
                    RpcPort = Input.RpcPort,

                    RealmName = Input.RealmName,
                    Username = Input.Username,
                    Password = Input.Password,
                    RealmID = RealmID,

                    Active = Input.Active,
                    Production = Input.ProductionRealm
                }))
                {
                    ModelState.AddModelError("Error", localizer.GetString("CouldNotUpdateRealm"));
                    return Page();
                }

                success = true;
                return RedirectToPage();
            }
            finally
            {
                await eventLogger.LogAsync(logType, success, data);
            }
        }

        public class InputModel
        {
            public Guid RealmID { get; set; }
            [Required]
            [MinLength(4)]
            [MaxLength(16)]
            public string RealmName { get; set; }
            [Required]
            [MaxLength(16)]
            public string GameIPAddress { get; set; }
            [Required]
            [MaxLength(16)]
            public string RpcIPAddress { get; set; } = "127.0.0.1";
            [Required]
            public uint GamePort { get; set; } = 5816;
            [Required]
            public uint RpcPort { get; set; } = 5817;
            [Required]
            [MaxLength(16)]
            public string Username { get; set; }
            [MaxLength(16)]
            [DataType(DataType.Password)]
            public string Password { get; set; }

            [Required]
            public string DatabaseHost { get; set; } = "localhost";
            [Required]
            public string DatabaseUser { get; set; } = "root";
#if !DEBUG
            [MinLength(20)]
            [MaxLength(100)]
#endif
            [DataType(DataType.Password)]
            public string DatabasePass { get; set; }
            [Required]
            public string DatabaseSchema { get; set; } = "cq";
            [Required]
            public uint DatabasePort { get; set; } = 3306;

            [Required]
            public bool Active { get; set; } = true;
            [Required]
            public bool ProductionRealm { get; set; } = true;

            [Required]
            public string GmToolsHost { get; set; }
            [Required]
            public int GmToolsPort { get; set; } = 4350;
            [Required]
            public string GmToolsUserName { get; set; }
            [DataType(DataType.Password)]
            public string GmToolsPassword { get; set; }

        }
    }
}

Canyon.GM.Panel/Areas/Realm/Pages/List.cshtml.cs
using Canyon.GM.Panel.Sockets.Piglet;
using Canyon.GM.Panel.Sockets.Piglet.Packets;
using Canyon.Network.Packets.Piglet;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using System.ComponentModel.DataAnnotations;

namespace Canyon.GM.Panel.Areas.Realm.Pages
{
    [Authorize(Roles = ROLE_MANAGE_REALMS)]
    public class ListModel : PageModel
    {
        private readonly RealmService realmService;
        private readonly RealmSocketService realmSocketService;

        public ListModel(RealmService realmService, RealmSocketService realmSocketService)
        {
            this.realmService = realmService;
            this.realmSocketService = realmSocketService;
        }

        public List<RealmData> Realms { get; } = new();

        [BindProperty]
        public RealmAction Input { get; set; }
        

        public async Task<IActionResult> OnGetAsync()
        {
            var realms = await realmService.QueryRealmsAsync(0, int.MaxValue);
            foreach (var realm in realms)
            {
                var realmStatus = realmSocketService.GetServer(realm.RealmID);
                Realms.Add(new RealmData
                {
                    Data = realm,
                    Status = realmStatus?.RealmStatus ?? PigletActor.RealmState.Offline
                });
            }
            return Page();
        }

        public async Task<IActionResult> OnPostStartServerAsync() 
        {
            if (!realmSocketService.IsRealmConnected(Input.RealmID))
            {
                ModelState.AddModelError("Error", "PigletIsNotConnected");
                return await OnGetAsync();
            }

            // todo sanity checks before starting sever
            // todo check if not already starting

            await realmSocketService.SendToRealmAsync(Input.RealmID, new MsgPigletRealmAction
            {
                Data = new MsgPigletRealmAction<PigletActor>.ActionData
                {
                    ActionType = MsgPigletRealmAction<PigletActor>.ActionDataType.StartServer,
                    Strings = new List<string>()
                }
            });
            return RedirectToPage();
        }

        public async Task<IActionResult> OnPostAnnounceMaintenanceAsync()
        {
            if (!realmSocketService.IsRealmConnected(Input.RealmID))
            {
                ModelState.AddModelError("Error", "RealmIsNotConnected");
                return await OnGetAsync();
            }

            await realmSocketService.SendToRealmAsync(Input.RealmID, new MsgPigletRealmAnnounceMaintenance
            {
                Data = new MsgPigletRealmAnnounceMaintenance<PigletActor>.AnnounceData
                {
                    WarningMinutes = 5
                }
            });
            return RedirectToPage();
        }

        public async Task<IActionResult> OnPostStopServerAsync()
        {
            if (!realmSocketService.IsRealmConnected(Input.RealmID))
            {
                ModelState.AddModelError("Error", "RealmIsNotConnected");
                return await OnGetAsync();
            }

            await realmSocketService.SendToRealmAsync(Input.RealmID, new MsgPigletShutdown
            {
                Data = new MsgPigletShutdown<PigletActor>.ShutdownData
                {
                    Id = int.MaxValue
                }
            });
            return RedirectToPage();
        }

        public class RealmAction
        {
            [Required]
            public Guid RealmID { get; set; }
        }

        public struct RealmData
        {
            public RealmService.RealmPublicListData Data { get; set; }
            public PigletActor.RealmState Status { get; set; }
        }
    }
}

Canyon.GM.Panel/Areas/Realm/Pages/Index.cshtml
@page "{RealmID}"
@using Microsoft.Extensions.Localization;
@inject IStringLocalizer StringLocalizer;
@model Canyon.GM.Panel.Areas.Realm.Pages.IndexModel
@{
    if (Model.RealmID.Equals(default))
    {
        ViewData[TITLE] = StringLocalizer.GetString("NewRealm");
    }
    else
    {
        ViewData[TITLE] = StringLocalizer.GetString("RealmManagement", Model.Realm.RealmName);
    }
}

<form method="post">

    <div class="mt-30 mb-40">

        @await Html.PartialAsync("_ErrorSummary")

        <div class="row mt-2">
            <div class="col-md-6">
                <div class="row">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("RealmID")</label>
                    <div class="col-sm-8">
                        @Model.Realm.RealmID
                    </div>
                </div>
            </div>
            <div class="col-md-6">
                <div class="row">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("RealmName")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.RealmName" />
                    </div>
                </div>
            </div>
        </div>

        <div class="row mt-2">
            <div class="col-md-6">
                <div class="row">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("Active")</label>
                    <div class="col-sm-8">
                        <div class="checkbox">
                            <label>
                                <input type="checkbox" asp-for="Input.Active">
                            </label>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-md-6">
                <div class="row">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("Production")</label>
                    <div class="col-sm-8">
                        <div class="checkbox">
                            <label>
                                <input type="checkbox" asp-for="Input.ProductionRealm">
                            </label>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="row mt-3">
            <div class="col-md-6">
                <h3>@StringLocalizer["DatabaseInformation"]</h3>

                <p>&nbsp;</p>

                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("Hostname")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.DatabaseHost" />
                    </div>
                </div>

                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("Port")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.DatabasePort" />
                    </div>
                </div>

                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("UserName")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.DatabaseUser" />
                    </div>
                </div>

                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("Password")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.DatabasePass" />
                    </div>
                </div>

                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("Schema")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.DatabaseSchema" />
                    </div>
                </div>
            </div>

            <div class="col-md-6">
                <h3>@StringLocalizer["RealmConnectivity"]</h3>
                <p>&nbsp;</p>
                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("RpcIPAddress")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.RpcIPAddress" />
                    </div>
                </div>

                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("RpcPort")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.RpcPort" />
                    </div>
                </div>

                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("GameIPAddress")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.GameIPAddress" />
                    </div>
                </div>

                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("GamePort")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.GamePort" />
                    </div>
                </div>

                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("UserName")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.Username" />
                    </div>
                </div>

                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("Password")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.Password" />
                    </div>
                </div>
            </div>
        </div>

        <div class="row mt-2">
            <div class="col-md-6">
                <h3>@StringLocalizer["GmToolsSettings"]</h3>
                <p>&nbsp;</p>
                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("GmToolsHost")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.GmToolsHost" />
                    </div>
                </div>

                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("GmToolsPort")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.GmToolsPort" />
                    </div>
                </div>

                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("GmToolsUserName")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.GmToolsUserName" />
                    </div>
                </div>

                <div class="row mt-2">
                    <label class="control-label col-sm-4">@StringLocalizer.GetString("GmToolsPassword")</label>
                    <div class="col-sm-8">
                        <input class="form-control" asp-for="Input.GmToolsPassword" />
                    </div>
                </div>
            </div>
        </div>

    </div>

    <button class="btn btn-dark mt-3" type="submit">@StringLocalizer["Submit"]</button>
</form>

Canyon.GM.Panel/Areas/Realm/Pages/List.cshtml
@page
@using Canyon.Backend.Web.Services;
@using Canyon.GM.Panel.Services.Core;
@using Microsoft.AspNetCore.Mvc.Localization;
@inject IStringLocalizer StringLocalizer;
@inject IHtmlLocalizer HtmlLocalizer;
@model Canyon.GM.Panel.Areas.Realm.Pages.ListModel
@{
    ViewData[TITLE] = StringLocalizer.GetString("RealmManageTitle");
}

<div class="mb-2">
    <a class="btn btn-primary" asp-area="Realm" asp-page="/Index" asp-route-RealmID="@Guid.Empty">
        <i class="fa-solid fa-plus" aria-hidden="true"></i>
        @StringLocalizer["NewRealm"]
    </a>
</div>
<div class="table-responsive">
    <div class="alert alert-warning" role="alert">
        <h4 class="alert-heading">@StringLocalizer["TemporaryRealmActionNotificationTitle"]</h4>
        @HtmlLocalizer["HtmlTemporaryRealmActionNotificationContent"]
    </div>
    @await Html.PartialAsync("_ErrorSummary")
    <table class="table table-hover">
        <caption>
            @StringLocalizer["RealmList"]
        </caption>
        <thead>
            <tr>
                <th scope="col">@StringLocalizer["RealmID"]</th>
                <th scope="col">@StringLocalizer["RealmName"]</th>
                <th scope="col">@StringLocalizer["Action"]</th>
                <th scope="col">&nbsp;</th>
            </tr>
        </thead>
        <tbody>
            @foreach (var realm in Model.Realms)
            {
                <tr>
                    <td>@realm.Data.RealmID</td>
                    <td>@realm.Data.RealmName</td>                    
                    <td>
                        @if (realm.Status != Sockets.Piglet.PigletActor.RealmState.Offline)
                        {
                            <form method="post" asp-page-handler="AnnounceMaintenance" class="AnnounceMaintenanceFrm"><input type="hidden" asp-for="Input.RealmID" value="@realm.Data.RealmID" /><button class="btn btn-link" type="submit" data-bs-toggle="tooltip" data-bs-title="@StringLocalizer["AnnounceMaintenance"]"><i aria-hidden="true" class="fa fa-screwdriver-wrench"></i> @StringLocalizer["Maintenance"]</button></form>
                            <form method="post" asp-page-handler="StopServer" class="StopServerFrm"><input type="hidden" asp-for="Input.RealmID" value="@realm.Data.RealmID" /><button class="btn btn-link" type="submit" data-bs-toggle="tooltip" data-bs-title="@StringLocalizer["StopServer"]"><i aria-hidden="true" class="fa fa-power-off"></i> @StringLocalizer["Close"]</button></form>
                        }
                        else
                        {
                            <form method="post" asp-page-handler="StartServer" class="StartServerFrm"><input type="hidden" asp-for="Input.RealmID" value="@realm.Data.RealmID" /><button class="btn btn-link" type="submit" data-bs-toggle="tooltip" data-bs-title="@StringLocalizer["StartServer"]"><i aria-hidden="true" class="fa fa-play"></i> @StringLocalizer["Start"]</button></form>
                        }
                    </td>
                    <td>
                        <a class="btn btn-link" asp-area="Realm" asp-page="/Index" asp-route-RealmID="@realm.Data.RealmID">
                            <i aria-hidden="true" class="fa fa-search"></i>
                        </a>
                    </td>
                </tr>
            }
        </tbody>
    </table>
</div>

@section Scripts
{
    <script>
        const tooltipTriggerList = document.querySelectorAll('[data-bs-toggle="tooltip"]');
        const tooltipList = [...tooltipTriggerList].map(tooltipTriggerEl => new bootstrap.Tooltip(tooltipTriggerEl));

        $('.StartServerFrm').submit(function (e) {
            e.preventDefault();
            const $this = $(this);
            ModalAlert({
                type: 'confirm',
                headerText: '@StringLocalizer["RealmAction"]',
                messageText: '@StringLocalizer["StartServerConfirmation"]',
                alertType: 'info',
                yesButtonText: '@StringLocalizer["Yes"]',
                noButtonText: '@StringLocalizer["No"]'
            }).done(function (confirmResult) {
                if (confirmResult === true) {
                    $this.unbind('submit').submit();
                }
            });
        });

        $('.AnnounceMaintenanceFrm').submit(function (e) {
            e.preventDefault();
            const $this = $(this);
            ModalAlert({
                type: 'confirm',
                headerText: '@StringLocalizer["RealmAction"]',
                messageText: '@StringLocalizer["AnnounceMaintenanceConfirmation"]',
                alertType: 'info',
                yesButtonText: '@StringLocalizer["Yes"]',
                noButtonText: '@StringLocalizer["No"]'
            }).done(function (confirmResult) {
                if (confirmResult === true) {
                    $this.unbind('submit').submit();
                }
            });
        });

        $('.StopServerFrm').submit(function (e) {
            e.preventDefault();
            const $this = $(this);
            ModalAlert({
                type: 'confirm',
                headerText: '@StringLocalizer["RealmAction"]',
                messageText: '@StringLocalizer["StopServerConfirmation"]',
                alertType: 'info',
                yesButtonText: '@StringLocalizer["Yes"]',
                noButtonText: '@StringLocalizer["No"]'
            }).done(function (confirmResult) {
                if (confirmResult === true) {
                    $this.unbind('submit').submit();
                }
            });
        });

    </script>
}